//------------------------------------------------------------------------------
//
// Copyright (c) 2004-2005  Matt Brunk  <info@smartcache.net>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License VERSION 2 as
// published by the Free Software Foundation.  You are not allowed to
// use any other version of the license; unless you got the explicit
// permission from the author to do so.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//------------------------------------------------------------------------------
#include "stdafx.h"
#include "EnumPorts.h"

static std::vector<int> s_ports;

BOOL CEnumPorts::IsPortAvailable(int nPort)
{
	TCHAR		szPort[15];
	COMMCONFIG	cc;
	DWORD		dwCCSize;

	sprintf(szPort, _T("COM%d"), nPort);

	dwCCSize = sizeof(cc);
	return GetDefaultCommConfig(szPort, &cc, &dwCCSize);
}

void CEnumPorts::GetAvailablePorts(std::vector<int> &outPorts)
{
	if ( s_ports.size() == 0 )
	{
		for ( int pp = 1; pp <= 255; pp++ )
		{
			if ( IsPortAvailable(pp) )
			{
				s_ports.push_back(pp);
			}
		}
	}

	outPorts = s_ports;
}

