#ifndef SOFTCARDTYPES_H_INCLUDED__
#define SOFTCARDTYPES_H_INCLUDED__

typedef unsigned char U8;
typedef unsigned short U16;
static const int MAX_ATR_LENGTH = 128;

static const U8	ATR_REVISION_IDX					= 7;
static const U8	ATR_OPTION_REGISTER_IDX				= 8;
static const U8	ATR_SECURITY_OPTION_REGISTER_IDX	= 9;
static const U8	ATR_N_OF_FILE_IDX					= 10;
static const U8	ATR_PERSONALIZATION_FILE_IDX		= 11;
static const U8	ATR_LIFECYCLE_STAGE_IDX				= 16;

typedef enum
{
	STAGE_USER,
	STAGE_MANUFACTURING,
	STAGE_PERSONALIZATION,
	STAGE_INVALID,
	NUM_STAGES
} StageEnum;

typedef enum
{
	INS_SUBMIT_CODE		= 0x20,
	INS_SELECT_FILE		= 0xA4,
	INS_READ_RECORD		= 0xB2,
	INS_WRITE_RECORD	= 0xD2,
	INS_START_SESSION	= 0x84,
	INS_AUTHENTICATE	= 0x82,
	INS_GET_RESPONSE	= 0xC0,
	NUM_INS
} InsEnum;

typedef struct
{
	BOOL	bAcos1;
	U8		revision;
	int		stage;
	U8		acos1Atr[MAX_ATR_LENGTH];
	UINT	iAcos1AtrLength;
	U8		otherAtr[MAX_ATR_LENGTH];
	UINT	iOtherAtrLength;
} AtrStruct;

#endif	// SOFTCARDTYPES_H_INCLUDED__
