//------------------------------------------------------------------------------
//
// Copyright (c) 2004-2005  Matt Brunk  <info@smartcache.net>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License VERSION 2 as
// published by the Free Software Foundation.  You are not allowed to
// use any other version of the license; unless you got the explicit
// permission from the author to do so.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//------------------------------------------------------------------------------
#include "stdafx.h"
#include <multimon.h>
#include "Utils.h"

static LPCTSTR PLACEMENT_FORMAT = _T("%u,%u,%d,%d,%d,%d,%d,%d,%d,%d");

BOOL CUtils::ReadWindowPlacement(LPCTSTR lpszSection, LPCTSTR lpszEntry, WINDOWPLACEMENT *pwp)
{
	CString 		strBuffer;
	int				nRead ;
	
	strBuffer = AfxGetApp()->GetProfileString(lpszSection, lpszEntry);
	if ( strBuffer.IsEmpty() ) 
	{
		return FALSE;
	}

	nRead = _stscanf
	(
		(LPCTSTR)strBuffer,
		PLACEMENT_FORMAT,
		&pwp->flags,
		&pwp->showCmd,
		&pwp->ptMinPosition.x,
		&pwp->ptMinPosition.y,
		&pwp->ptMaxPosition.x,
		&pwp->ptMaxPosition.y,
		&pwp->rcNormalPosition.left,
		&pwp->rcNormalPosition.top,
		&pwp->rcNormalPosition.right,
		&pwp->rcNormalPosition.bottom
	);

	if ( nRead != 10 )
	{
		return FALSE;
	}
	else
	{
		CRect	screenRect;
		CRect	winRect;
		CRect	intersectRect;

		winRect.SetRect
		(
			pwp->rcNormalPosition.left,
			pwp->rcNormalPosition.top,
			pwp->rcNormalPosition.right,
			pwp->rcNormalPosition.bottom
		);

		GetVirtualDesktopRect(screenRect);
		if ( !intersectRect.IntersectRect(screenRect, winRect) )
		{
			return FALSE;
		}
	}

	pwp->length = sizeof(WINDOWPLACEMENT);

	return TRUE;
}

void CUtils::WriteWindowPlacement(LPCTSTR lpszSection, LPCTSTR lpszEntry, WINDOWPLACEMENT *pwp)
{
	CString	sss;

	sss.Format
	(
		PLACEMENT_FORMAT,
		pwp->flags,
		pwp->showCmd,
		pwp->ptMinPosition.x,
		pwp->ptMinPosition.y,
		pwp->ptMaxPosition.x,
		pwp->ptMaxPosition.y,
		pwp->rcNormalPosition.left,
		pwp->rcNormalPosition.top,
		pwp->rcNormalPosition.right,
		pwp->rcNormalPosition.bottom
	);

 	AfxGetApp()->WriteProfileString(lpszSection, lpszEntry, sss);

}

int CUtils::GetDayOfYear()
{
	COleDateTime oletimeTime = COleDateTime::GetCurrentTime();
	return oletimeTime.GetDayOfYear();
}

// returns the rectangle that is the union of all active monitors
void CUtils::GetVirtualDesktopRect(CRect &r)
{
	r.SetRect
	(
		::GetSystemMetrics( SM_XVIRTUALSCREEN ),
		::GetSystemMetrics( SM_YVIRTUALSCREEN ),
		::GetSystemMetrics( SM_CXVIRTUALSCREEN ),
		::GetSystemMetrics( SM_CYVIRTUALSCREEN ) 
	);	
}
