//------------------------------------------------------------------------------
//
// Copyright (c) 2004-2005  Matt Brunk  <info@smartcache.net>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License VERSION 2 as
// published by the Free Software Foundation.  You are not allowed to
// use any other version of the license; unless you got the explicit
// permission from the author to do so.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//------------------------------------------------------------------------------
#include "stdafx.h"
#include <time.h>
#include "guid.h"
#include "Random.h"

void CGUID::MakeGUID(unsigned char outGUID[GUID_LENGTH], bool bUseRandom /*= false*/)
{
	GUID	guid;
	HRESULT	hr;

	if ( !bUseRandom )
	{
		hr = ::CoCreateGuid(&guid);
		if ( hr == S_OK )
		{
			::CopyMemory(outGUID, &guid, sizeof guid);
		}
		else
		{
			bUseRandom = true;
		}
	}

	if ( bUseRandom )
	{
		//----------------------------------------------------------------------
		//	Fill with random pattern.
		//----------------------------------------------------------------------
		size_t	bytesRemaining = GUID_LENGTH;
		size_t	currIdx = 0;

		while ( bytesRemaining > 0 )
		{
			unsigned long r = CRandom::genrand();
			if ( bytesRemaining >= sizeof(r) )
			{
				::CopyMemory(&outGUID[currIdx], &r, sizeof(r));
				currIdx += sizeof(r);
				bytesRemaining -= sizeof(r);
			}
			else
			{
				::CopyMemory(&outGUID[currIdx], &r, bytesRemaining);
				bytesRemaining = 0;
			}
		}
			
	}
}

